Imports System.Runtime.InteropServices
Imports System.IO
Imports System.ComponentModel
Module ChgOwner

    Private Const SE_FILE_OBJECT As Integer = 1&
    Private Const OWNER_SECURITY_INFORMATION As Integer = &H1

    Private Const NAME_SIZE As Integer = 64
    Private Const SID_SIZE As Integer = 32

    'DWORD SetNamedSecurityInfo(
    '  LPTSTR pObjectName,
    '  SE_OBJECT_TYPE ObjectType,
    '  SECURITY_INFORMATION SecurityInfo,
    '  PSID psidOwner,
    '  PSID psidGroup,
    '  PACL pDacl,
    '  PACL pSacl
    ');
    Declare Auto Function SetNamedSecurityInfo Lib "AdvAPI32.DLL" ( _
    ByVal pObjectName As String, _
    ByVal ObjectType As Integer, _
    ByVal SecurityInfo As Integer, _
    ByVal psidOwner As IntPtr, _
    ByVal psidGroup As IntPtr, _
    ByVal pDacl As IntPtr, _
    ByVal pSacl As IntPtr) As Integer

    'BOOL LookupAccountName(
    '  LPCTSTR lpSystemName,
    '  LPCTSTR lpAccountName,
    '  PSID Sid,
    '  LPDWORD cbSid,
    '  LPTSTR ReferencedDomainName,
    '  LPDWORD cchReferencedDomainName,
    '  PSID_NAME_USE peUse
    ');
    Declare Auto Function LookupAccountName Lib "advapi32.dll" ( _
    ByVal lpSystemName As String, _
    ByVal lpAccountName As String, _
    ByVal Sid As IntPtr, _
    ByRef cbSid As Integer, _
    ByVal lpReferencedDomainName As String, _
    ByRef cchReferencedDomainName As Integer, _
    ByRef peUse As IntPtr) As Boolean

    Public Declare Function LocalFree Lib "kernel32" ( _
    ByVal hMem As IntPtr) As Integer

    Sub ChangeOwner(ByRef strPath As String, ByVal strUserName As String)
        Dim pNewOwner, deUse As IntPtr
        Dim Win32Error As Win32Exception
        Dim domain_name As String
        Dim ret, sid_len, domain_len As Integer

        ' Series of quick sanity checks before we proceed...

        ' Do we have the required Privilege?
        If SetPrivileges() = False Then
            Throw New Exception("Required privilege not held by the user")
        End If

        ' Does the file even exist?
        If File.Exists(strPath) = False Then
            If Directory.Exists(strPath) = False Then
                Throw New Exception("File or Directory not found")
            End If
        End If

        ' Convert the name to a valid SID
        sid_len = SID_SIZE
        pNewOwner = Marshal.AllocHGlobal(sid_len)
        domain_len = NAME_SIZE
        domain_name = Space(domain_len)
        If LookupAccountName(Nothing, strUserName, pNewOwner, sid_len, domain_name, domain_len, deUse) = False Then
            ret = Marshal.GetLastWin32Error()
            Win32Error = New Win32Exception(ret)
            Throw New Exception(Win32Error.Message)
        End If

        ' write the new Owner
        ret = SetNamedSecurityInfo(strPath, SE_FILE_OBJECT, OWNER_SECURITY_INFORMATION, pNewOwner, Nothing, Nothing, Nothing)
        If ret <> 0 Then
            Win32Error = New Win32Exception(ret)
            Throw New Exception(Win32Error.Message)
        End If

        ' clean up and go home
        Marshal.FreeHGlobal(pNewOwner)
    End Sub
End Module
